import React from 'react';
import SuiButton from '@s-ui/react-atom-button';
import TcfSecondLayerUserDecision from '../tcf-secondLayer-user-decision';
export default function TcfSecondLayerDecisionGroup(_ref) {
  var _descriptionKeys;

  var name = _ref.name,
      i18n = _ref.i18n,
      baseClass = _ref.baseClass,
      descriptions = _ref.descriptions,
      state = _ref.state,
      filteredIds = _ref.filteredIds,
      hasConsent = _ref.hasConsent,
      hasLegitimateInterest = _ref.hasLegitimateInterest,
      _onConsentChange = _ref.onConsentChange,
      _onLegitimateInterestChange = _ref.onLegitimateInterestChange,
      onAcceptAll = _ref.onAcceptAll,
      onRejectAll = _ref.onRejectAll,
      vendorList = _ref.vendorList,
      expandedContent = _ref.expandedContent;
  var descriptionKeys = descriptions && Object.keys(descriptions).map(function (key) {
    return parseInt(key);
  });

  if (filteredIds) {
    descriptionKeys = descriptionKeys.filter(function (key) {
      return filteredIds.includes(key);
    });
  }

  if (!((_descriptionKeys = descriptionKeys) == null ? void 0 : _descriptionKeys.length)) {
    return null;
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-title-container"
  }, /*#__PURE__*/React.createElement("h2", {
    className: baseClass + "-title"
  }, name), hasConsent || hasLegitimateInterest ? /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-buttons"
  }, /*#__PURE__*/React.createElement(SuiButton, {
    size: "small",
    design: "outline",
    onClick: onRejectAll
  }, i18n.DISABLE_BUTTON), /*#__PURE__*/React.createElement(SuiButton, {
    size: "small",
    onClick: onAcceptAll
  }, i18n.ENABLE_BUTTON)) : null), descriptionKeys.map(function (key, index) {
    var _state$legitimateInte;

    var consentValue = (state == null ? void 0 : state.consents) ? state.consents[key] : state == null ? void 0 : state[key];
    return /*#__PURE__*/React.createElement(TcfSecondLayerUserDecision, {
      key: key + "-" + index,
      baseClass: baseClass + "-item",
      info: descriptions[key],
      consentValue: consentValue,
      legitimateInterestValue: state == null ? void 0 : (_state$legitimateInte = state.legitimateInterestValue) == null ? void 0 : _state$legitimateInte[key],
      hasConsent: hasConsent,
      hasLegitimateInterest: hasLegitimateInterest,
      i18n: i18n,
      vendorList: vendorList,
      onConsentChange: function onConsentChange(value) {
        return _onConsentChange({
          index: key,
          value: value
        });
      },
      onLegitimateInterestChange: function onLegitimateInterestChange(value) {
        return _onLegitimateInterestChange({
          index: key,
          value: value
        });
      },
      expandedContent: expandedContent
    });
  }));
}