import React, { useState } from 'react';
import SuiSwitch from '@s-ui/react-atom-switch';
import IconAccordion from '../iconAccordion';
export default function TcfSecondLayerUserDecision(_ref) {
  var onConsentChange = _ref.onConsentChange,
      onLegitimateInterestChange = _ref.onLegitimateInterestChange,
      baseClass = _ref.baseClass,
      info = _ref.info,
      consentValue = _ref.consentValue,
      legitimateInterestValue = _ref.legitimateInterestValue,
      _ref$hasConsent = _ref.hasConsent,
      hasConsent = _ref$hasConsent === void 0 ? true : _ref$hasConsent,
      _ref$hasLegitimateInt = _ref.hasLegitimateInterest,
      hasLegitimateInterest = _ref$hasLegitimateInt === void 0 ? true : _ref$hasLegitimateInt,
      vendorList = _ref.vendorList,
      expandedContent = _ref.expandedContent,
      i18n = _ref.i18n;

  var _useState = useState(false),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var handleItemClick = function handleItemClick() {
    setExpanded(!expanded);
  };

  var Switchs = function Switchs() {
    return /*#__PURE__*/React.createElement("div", {
      className: baseClass + "-switchs"
    }, hasConsent && /*#__PURE__*/React.createElement(SuiSwitch, {
      type: "single",
      name: "groupItem",
      value: consentValue,
      label: i18n.CONSENT_COPY,
      onToggle: function onToggle() {
        return onConsentChange(consentValue);
      }
    }), hasLegitimateInterest && /*#__PURE__*/React.createElement(SuiSwitch, {
      type: "single",
      name: "groupItem",
      value: legitimateInterestValue,
      label: i18n.LEGITIMATE_INTEREST_COPY,
      onToggle: function onToggle() {
        return onLegitimateInterestChange(legitimateInterestValue);
      }
    }));
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container-clicklable",
    onClick: handleItemClick
  }, /*#__PURE__*/React.createElement(IconAccordion, {
    baseClass: expanded ? baseClass + "-icon-accordion " + baseClass + "-icon-accordion--expanded" : baseClass + "-icon-accordion"
  }), /*#__PURE__*/React.createElement("p", {
    className: baseClass + "-text"
  }, info.name)), hasConsent || hasLegitimateInterest ? /*#__PURE__*/React.createElement(Switchs, null) : null), expanded && /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container--expanded"
  }, expandedContent({
    info: info,
    baseClass: baseClass
  })));
}
TcfSecondLayerUserDecision.defaultProps = {
  hasConsent: true,
  hasLegitimateInterest: true
};