import _extends from "@babel/runtime/helpers/esm/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import SuiModal from '@s-ui/react-molecule-modal';
import SuiButton from '@s-ui/react-atom-button';
import IconClose from './components/iconClose';
import TcfSecondLayerDecisionGroup from './components/tcf-secondLayer-decision-group';
import TcfSecondLayerVendorExpandedContent from './components/tcf-secondLayer-vendor-expandedContent';
import { I18N, ADEVINTA_COLLECTED_CONSENTS } from './settings';
import TcfSecondLayerLegalExpandedContent from './components/tcf-secondLayer-legal-expandedContent';
var CLASS = 'sui-TcfSecondLayer';
var groupBaseClass = CLASS + "-group";
export default function TcfSecondLayer(_ref) {
  var isMobile = _ref.isMobile,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'es' : _ref$lang,
      logo = _ref.logo,
      loadUserConsent = _ref.loadUserConsent,
      saveUserConsent = _ref.saveUserConsent,
      getVendorList = _ref.getVendorList,
      onGoBack = _ref.onGoBack;

  var _useState = useState(null),
      state = _useState[0],
      setState = _useState[1];

  var _useState2 = useState(true),
      modalOpen = _useState2[0],
      setModalOpen = _useState2[1];

  var _useState3 = useState(null),
      vendorListState = _useState3[0],
      setVendorListState = _useState3[1];

  var i18n = I18N[lang];
  useEffect(function () {
    var getVendorListAndConsent = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _yield$getVendorList, purposes, specialPurposes, features, specialFeatures, vendors, userConsent;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return getVendorList({
                  language: lang
                });

              case 2:
                _yield$getVendorList = _context.sent;
                purposes = _yield$getVendorList.purposes;
                specialPurposes = _yield$getVendorList.specialPurposes;
                features = _yield$getVendorList.features;
                specialFeatures = _yield$getVendorList.specialFeatures;
                vendors = _yield$getVendorList.vendors;
                setVendorListState({
                  purposes: purposes,
                  specialPurposes: specialPurposes,
                  features: features,
                  specialFeatures: specialFeatures,
                  vendors: vendors
                });
                _context.next = 11;
                return loadUserConsent();

              case 11:
                userConsent = _context.sent;

                if (userConsent.isNew) {
                  userConsent.vendor.consents = format({
                    reference: vendors,
                    object: {},
                    value: true
                  });
                }

                setState({
                  vendors: userConsent.vendor,
                  purposes: userConsent.purpose,
                  specialFeatures: userConsent.specialFeatures
                });

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function getVendorListAndConsent() {
        return _ref2.apply(this, arguments);
      };
    }();

    getVendorListAndConsent();
  }, [getVendorList, loadUserConsent, lang]);

  var handleCloseModal = function handleCloseModal() {
    setModalOpen(false);
  };

  var format = function format(_ref3) {
    var reference = _ref3.reference,
        object = _ref3.object,
        _ref3$value = _ref3.value,
        value = _ref3$value === void 0 ? false : _ref3$value;
    Object.keys(reference).forEach(function (key) {
      if (!object[key]) {
        object[key] = value;
      }
    });
    return object;
  };

  var formatConsentObject = function formatConsentObject(_ref4) {
    var _ref4$vendor = _ref4.vendor,
        vendor = _ref4$vendor === void 0 ? {} : _ref4$vendor;
    vendor.consents = format({
      reference: vendorListState.vendors || {},
      object: vendor.consents || {}
    });
    return {
      vendor: vendor
    };
  };

  var handleSaveExitClick = function handleSaveExitClick() {
    saveUserConsent(formatConsentObject({
      vendor: state.vendors
    }));
    setModalOpen(false);
  };

  var changeAllGroup = function changeAllGroup(_ref5) {
    var group = _ref5.group,
        value = _ref5.value;
    setState(function (prevState) {
      var _extends2;

      for (var key in vendorListState[group]) {
        prevState[group].consents[key] = value;
        prevState[group].legitimateInterests[key] = value;
      }

      return _extends({}, prevState, (_extends2 = {}, _extends2[group] = prevState[group], _extends2));
    });
  };

  var handleRejectAll = function handleRejectAll(_ref6) {
    var group = _ref6.group;
    changeAllGroup({
      group: group,
      value: false
    });
  };

  var handleAcceptAll = function handleAcceptAll(_ref7) {
    var group = _ref7.group;
    changeAllGroup({
      group: group,
      value: true
    });
  };

  var handleAcceptAllSpecialFeatures = function handleAcceptAllSpecialFeatures() {
    var specialFeatures = {};
    ADEVINTA_COLLECTED_CONSENTS.specialFeatures.forEach(function (value) {
      return specialFeatures[value] = true;
    });
    setState(_extends({}, state, {
      specialFeatures: specialFeatures
    }));
  };

  var handleRejectAllSpecialFeatures = function handleRejectAllSpecialFeatures() {
    setState(_extends({}, state, {
      specialFeatures: {}
    }));
  };

  var handleConsentsChange = function handleConsentsChange(_ref8) {
    var group = _ref8.group,
        index = _ref8.index,
        value = _ref8.value;
    setState(function (prevState) {
      var consents = prevState[group].consents;

      if (consents) {
        var _extends3;

        consents[index] = !value;
        return _extends({}, prevState, (_extends3 = {}, _extends3[group] = _extends({}, prevState[group], {
          consents: consents
        }), _extends3));
      } else {
        var _extends4, _extends5;

        return _extends({}, prevState, (_extends5 = {}, _extends5[group] = _extends({}, prevState[group], (_extends4 = {}, _extends4[index] = !value, _extends4)), _extends5));
      }
    });
  };

  var Logo = function Logo() {
    return /*#__PURE__*/React.createElement("img", {
      className: isMobile ? CLASS + "-logo" : CLASS + "-logo " + CLASS + "-logo--desktop",
      src: logo,
      alt: "logo"
    });
  };

  var vendorExpandedContent = function vendorExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerVendorExpandedContent, Object.assign({}, props, {
      i18n: i18n,
      baseClass: groupBaseClass,
      vendorList: vendorListState
    }));
  };

  var legalExpandedContent = function legalExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerLegalExpandedContent, Object.assign({}, props, {
      baseClass: groupBaseClass
    }));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: CLASS
  }, /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: modalOpen,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: isMobile ? /*#__PURE__*/React.createElement(Logo, null) : false,
    iconClose: isMobile ? /*#__PURE__*/React.createElement(IconClose, null) : false,
    onClose: handleCloseModal,
    fitContent: true
  }, !isMobile && /*#__PURE__*/React.createElement(Logo, null), /*#__PURE__*/React.createElement("div", {
    className: isMobile ? CLASS + "-container" : CLASS + "-container " + CLASS + "-container--desktop"
  }, /*#__PURE__*/React.createElement("h2", {
    className: isMobile ? CLASS + "-title" : CLASS + "-title " + CLASS + "-title--desktop"
  }, i18n.VENDOR_PAGE.TITLE), /*#__PURE__*/React.createElement("p", {
    className: isMobile ? CLASS + "-text" : CLASS + "-text " + CLASS + "-text--desktop"
  }, i18n.VENDOR_PAGE.TEXT), !!(vendorListState == null ? void 0 : vendorListState.purposes) && !!(state == null ? void 0 : state.purposes) && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.purposes,
    state: state.purposes,
    filteredIds: ADEVINTA_COLLECTED_CONSENTS.purposes,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'purposes'
      }, props));
    },
    hasConsent: true,
    hasLegitimateInterest: false,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'purposes'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'purposes'
      });
    },
    vendorList: vendorListState,
    expandedContent: legalExpandedContent
  }), !!(vendorListState == null ? void 0 : vendorListState.specialFeatures) && !!(state == null ? void 0 : state.specialFeatures) && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialFeatures,
    state: state.specialFeatures,
    filteredIds: ADEVINTA_COLLECTED_CONSENTS.specialFeatures,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'specialFeatures'
      }, props));
    },
    hasConsent: true,
    hasLegitimateInterest: false,
    i18n: i18n,
    onAcceptAll: handleAcceptAllSpecialFeatures,
    onRejectAll: handleRejectAllSpecialFeatures,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent
  }), !!(vendorListState == null ? void 0 : vendorListState.specialPurposes) && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialPurposes,
    hasConsent: false,
    hasLegitimateInterest: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent
  }), !!(vendorListState == null ? void 0 : vendorListState.features) && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.features,
    hasConsent: false,
    hasLegitimateInterest: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent
  }), !!(state == null ? void 0 : state.vendors) && !!(vendorListState == null ? void 0 : vendorListState.vendors) && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.VENDOR_PAGE.GROUPS.TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.vendors,
    state: state.vendors,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'vendors'
      }, props));
    },
    hasConsent: true,
    hasLegitimateInterest: false,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'vendors'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'vendors'
      });
    },
    vendorList: vendorListState,
    expandedContent: vendorExpandedContent
  })), /*#__PURE__*/React.createElement("footer", {
    className: CLASS + "-buttons"
  }, /*#__PURE__*/React.createElement(SuiButton, {
    design: "outline",
    onClick: onGoBack
  }, i18n.GO_BACK_BUTTON), /*#__PURE__*/React.createElement(SuiButton, {
    onClick: handleSaveExitClick
  }, i18n.ACCEPT_BUTTON))));
}
TcfSecondLayer.displayName = 'TcfSecondLayer';